﻿-- clcInfo_ArmsWarrior options.lua -- Deronda
-- You can use this type of code to prevent loading for other classes.
local _, class = UnitClass("player")
if class ~= "WARRIOR" then return end

-- make sure clcInfo is loaded
if not clcInfo then return end
-- exposed vars

local modName = "____arms_warrior"
local mod, options, baseMod, db, tdb

local function GetDB(info)
	return db[info[5]]
end
local function SetDB(info, val)
	db[info[5]] = val
end

local function GetTDB(info)
	return tdb[info[#info]]
end

local function SetTDB(info, val)
	tdb[info[#info]] = val
	
	if info[#info] == "prio" then
		baseMod:UpdateQueue()
	end
end


local function LoadModule()
	mod = clcInfo_Options
	options = mod.options
	baseMod = clcInfo.classModules[modName]
	db = clcInfo:RegisterClassModuleDB(modName)
	tdb = clcInfo:RegisterClassModuleTDB(modName)
	
	local tx = {}
	for k, v in pairs(baseMod.actions) do
		table.insert(tx, format("\n%s - %s", k, v.info))
	end
	table.sort(tx)
	local prioInfo = "Legend:\n" .. table.concat(tx)
	
	options.args.classModules.args[modName] = {
		order = 2, type = "group", childGroups = "tab", name = "Arms",
		args = {
			tabPriority = {
				order = 1, type = "group", name = "Priority", args = {
					igPrio = {
						order = 1, type = "group", inline = true, name = "",
						args = {
							info = {
								order = 1, type = "description", name = prioInfo,
							},
							prio = {
								order = 2, type = "input", width = "full", name = "",
								get = GetTDB, set = SetTDB,
							},
							infoCMD = {
								order = 3, type = "description", name = "Sample command line usage: /clcinfo armsprio tfb15 shout ms2030 exebtrance rend cs exedcreck ms op exe slam",
							},
                            ignore_rend_op_less_than_20 = {
                                order = 4, type = "toggle", width = "full",
                                name = "No Rend, no Overpower if target health < 20%",
                                get = GetTDB, set = SetTDB,
                            },
						},
					},
				},
			},
		},
	}
end
-- function needs to be added to a clcInfo table, that stores the functions to be called when Options are loaded
clcInfo.optionsCMLoaders[#(clcInfo.optionsCMLoaders) + 1] = LoadModule